#!/bin/bash

#第一个参数来填写要配置的仓库名称
action=$1
#真实仓库的根目录
GITROOT="/home/git/repositories/"
#web所有项目根目录
WEBROOT="/home/wwwroot/"

Display_Menu()
{
    echo ""
    echo "#####################################################"
    read -p "请输入仓库名称(0或exit直接退出)： " action
}


echo "+-----------------------------------------------------------------------+"
echo "|            此程序是git自动部署项目（目录依赖gitosis）                    |"
echo "+-----------------------------------------------------------------------+"

    
#初始化action
Display_Menu

case "${action}" in
        0|[eE][xX][iI][tT])
            exit 1
            ;;
        *)
            echo "部署web项目：${WEBROOT}${action}"
            cd $WEBROOT
            git clone "git@127.0.0.1:${action}.git"
            chown git:git -R $action
            cd "${GITROOT}${action}.git/hooks/"
            cat >post-receive<<EOF
#!/bin/sh
unset GIT_DIR
CURRETNPATH=\`pwd\`
#项目目录
WEBPATH=${WEBROOT}${action}
cd \$WEBPATH
git reset --hard && git clean -f && git pull 2>&1
cd \$CURRETNPATH
exit 0
EOF
            chmod +x post-receive

            exit 0
            ;;
esac

